package de.ozgcloud.nachrichten.postfach.osiv2.factory;

import java.time.OffsetDateTime;
import java.util.UUID;

import de.ozgcloud.nachrichten.postfach.osiv2.gen.model.V1EidasLevel;
import de.ozgcloud.nachrichten.postfach.osiv2.gen.model.V1ReplyBehavior;
import de.ozgcloud.nachrichten.postfach.osiv2.gen.model.V1ReplyMessage;

public class V1ReplyMessageTestFactory {

	private static final String SEQUENCE_NUMMER = "OZG-Cloud-VorgangId";
	private static final String SUBJECT = "Das ist das Subject";
	public static final String HTML_REPLY_BODY = """
			Das ist das Multiline&amp;&lt;b&gt;a&lt;/b&gt<br><br/>
			Body""";
	public static final String REPLY_BODY = """
			Das ist das Multiline&<b>a</b>
			
			
			Body""";
	private static final String DISPLAY_NAME = "Das ist der Absender";
	private static final String ORIGIN_SENDER = "das ist der original Sender";
	private static final String REPLAY_ACTION = "Replypossible";
	private static final String EIDAS_LEVEL = "Low";
	private static final Boolean IS_OBLIGATORY = Boolean.FALSE;
	private static final Boolean IS_HTML = Boolean.FALSE;
	private static final String GUID = "123-guid-456";
	private static final String MESSAGE_BOX = "Mailbox-Id-Antwortender";
	private static final OffsetDateTime RESPONSE_TIME = OffsetDateTime.now();

	public static V1ReplyMessage create() {
		return new V1ReplyMessage()
				.sequencenumber(SEQUENCE_NUMMER)
				.subject(SUBJECT)
				.body(REPLY_BODY)
				.displayName(DISPLAY_NAME)
				.originSender(ORIGIN_SENDER)
				.replyAction(V1ReplyBehavior.fromValue(REPLAY_ACTION))
				.eidasLevel(V1EidasLevel.fromValue(EIDAS_LEVEL))
				.isObligatory(IS_OBLIGATORY)
				.isHtml(IS_HTML)
				.guid(UUID.nameUUIDFromBytes(GUID.getBytes()))
				.messageBox(UUID.nameUUIDFromBytes(MESSAGE_BOX.getBytes()))
				.responseTime(RESPONSE_TIME);
	}
}
